[PATCH 2/3] test: Add `test_emacs_expect_t'.
David Edmondson
dme at dme.org
Tue Jan 17 06:07:03 PST 2012
Add a new test function to allow simpler testing of emacs
functionality.
`test_emacs_expect_t' takes one argument - a list expression to
evaluate. The test passes if the expression returns `t', otherwise it
fails and the output is reported to the tester.
---
Re-worked as Dmitry suggested.
test/README | 8 ++++++++
test/emacs-test-functions.sh | 9 +++++++++
test/notmuch-test | 1 +
test/test-lib.sh | 33 +++++++++++++++++++++++++++++++++
4 files changed, 51 insertions(+), 0 deletions(-)
create mode 100755 test/emacs-test-functions.sh
diff --git a/test/README b/test/README
index bde6db0..9dbe2ee 100644
--- a/test/README
+++ b/test/README
@@ -189,6 +189,14 @@ library for your script to use.
tests that may run in the same Emacs instance. Use `let' instead
so the scope of the changed variables is limited to a single test.
+ test_emacs_expect_t <emacs-lisp-expressions>
+
+ This function executes the provided emacs lisp script within
+ emacs in a manner similar to 'test_emacs'. The expressions should
+ return the value `t' to indicate that the test has passed. If the
+ test does not return `t' then it is considered failed and all data
+ returned by the test is reported to the tester.
+
test_done
Your test script must have test_done at the end. Its purpose
diff --git a/test/emacs-test-functions.sh b/test/emacs-test-functions.sh
new file mode 100755
index 0000000..0e1f9fc
--- /dev/null
+++ b/test/emacs-test-functions.sh
@@ -0,0 +1,9 @@
+#!/usr/bin/env bash
+
+test_description="emacs test function sanity"
+. test-lib.sh
+
+test_begin_subtest "emacs test function sanity"
+test_emacs_expect_t 't'
+
+test_done
diff --git a/test/notmuch-test b/test/notmuch-test
index 6a99ae3..d034f99 100755
--- a/test/notmuch-test
+++ b/test/notmuch-test
@@ -52,6 +52,7 @@ TESTS="
python
hooks
argument-parsing
+ emacs-test-functions.sh
"
TESTS=${NOTMUCH_TESTS:=$TESTS}
diff --git a/test/test-lib.sh b/test/test-lib.sh
index 7c9ce24..4b05760 100644
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -503,6 +503,39 @@ test_expect_equal_file ()
fi
}
+test_emacs_expect_t () {
+ test "$#" = 1 || error "bug in the test script: not 1 parameter to test_emacs_expect_t"
+
+ # Run the test.
+ if ! test_skip "$test_subtest_name"
+ then
+ # We cannot call 'test_emacs' in a subshell, because
+ # the setting of EMACS_SERVER would not persist
+ # throughout a sequence of tests, so we use a
+ # temporary file.
+ tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
+ output="$tmp/test_emacs_output.$$"
+ test_emacs "$1" > "${output}"
+ result=$(cat "${output}")
+ rm -f "${output}"
+ fi
+
+ # Restore state after the test.
+ exec 1>&6 2>&7 # Restore stdout and stderr
+ inside_subtest=
+
+ # Report success/failure.
+ if ! test_skip "$test_subtest_name"
+ then
+ if [ "$result" == t ]
+ then
+ test_ok_ "$test_subtest_name"
+ else
+ test_failure_ "$test_subtest_name" "$(eval printf ${result})"
+ fi
+ fi
+}
+
NOTMUCH_NEW ()
{
notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
--
1.7.7.3
More information about the notmuch
mailing list